/*
 * Copyright (C) 2003-2005 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Marco Magistrali
//
#include "pim/ContactBuilder.h"

/*
* Method to populate the contact XML structure. 
* It get every property name and value and build the XML structure to exchange with server.
*
* @param contactStringItem  : the string that will contain the xml structure
* @param pAppointment       : the contact object that contain every value
*
*/
void populateContactStringItem(string &contactStringItem, IContact *pContact) {
	

	BSTR element = NULL;
	DATE date = NULL;
	wchar_t tempDate[50];
    
    contactStringItem = TEXT("<?xml version=\"1.0\"?>");
	contactStringItem = contactStringItem + TEXT("<contact>");
	
	pContact->get_FirstName(&element);
	contactStringItem  = contactStringItem + TEXT("<FirstName>") + element + TEXT("</FirstName>");
	
	pContact->get_LastName(&element);
	contactStringItem  = contactStringItem + TEXT("<LastName>") + element + TEXT("</LastName>");
	
	pContact->get_CompanyName(&element);
	contactStringItem  = contactStringItem + TEXT("<CompanyName>") + element + TEXT("</CompanyName>");
	
	pContact->get_BusinessFaxNumber(&element);
	contactStringItem  = contactStringItem + TEXT("<BusinessFaxNumber>") + element + TEXT("</BusinessFaxNumber>");
	
	pContact->get_Department(&element);
	contactStringItem  = contactStringItem + TEXT("<Department>") + element + TEXT("</Department>");
	
	pContact->get_Email1Address(&element);
	contactStringItem  = contactStringItem + TEXT("<Email1Address>") + element + TEXT("</Email1Address>");
	
	pContact->get_MobileTelephoneNumber(&element);
	contactStringItem  = contactStringItem + TEXT("<MobileTelephoneNumber>") + element + TEXT("</MobileTelephoneNumber>");
	
	pContact->get_OfficeLocation(&element);
	contactStringItem  = contactStringItem + TEXT("<OfficeLocation>") + element + TEXT("</OfficeLocation>");
	
	pContact->get_PagerNumber(&element);
	contactStringItem  = contactStringItem + TEXT("<PagerNumber>") + element + TEXT("</PagerNumber>");
	
	pContact->get_BusinessTelephoneNumber(&element);
	contactStringItem  = contactStringItem + TEXT("<BusinessTelephoneNumber>") + element + TEXT("</BusinessTelephoneNumber>");
	
	pContact->get_JobTitle(&element);
	contactStringItem  = contactStringItem + TEXT("<JobTitle>") + element + TEXT("</JobTitle>");
	
	pContact->get_HomeTelephoneNumber(&element);
	contactStringItem  = contactStringItem + TEXT("<HomeTelephoneNumber>") + element + TEXT("</HomeTelephoneNumber>");
	
	pContact->get_Email2Address(&element);
	contactStringItem  = contactStringItem + TEXT("<Email2Address>") + element + TEXT("</Email2Address>");
	
	pContact->get_Spouse(&element);
	contactStringItem  = contactStringItem + TEXT("<Spouse>") + element + TEXT("</Spouse>");
	
	pContact->get_Email3Address(&element);
	contactStringItem  = contactStringItem + TEXT("<Email3Address>") + element + TEXT("</Email3Address>");
	
	pContact->get_Home2TelephoneNumber(&element);
	contactStringItem  = contactStringItem + TEXT("<Home2TelephoneNumber>") + element + TEXT("</Home2TelephoneNumber>");
	
	pContact->get_HomeFaxNumber(&element);
	contactStringItem  = contactStringItem + TEXT("<HomeFaxNumber>") + element + TEXT("</HomeFaxNumber>");
	
	pContact->get_CarTelephoneNumber(&element);
	contactStringItem  = contactStringItem + TEXT("<CarTelephoneNumber>") + element + TEXT("</CarTelephoneNumber>");

	pContact->get_AssistantName(&element);
	contactStringItem  = contactStringItem + TEXT("<AssistantName>") + element + TEXT("</AssistantName>");
	
	pContact->get_AssistantTelephoneNumber(&element);
	contactStringItem  = contactStringItem + TEXT("<AssistantTelephoneNumber>") + element + TEXT("</AssistantTelephoneNumber>");

	pContact->get_Children(&element);
	contactStringItem  = contactStringItem + TEXT("<Children>") + element + TEXT("</Children>");

	pContact->get_Categories(&element);
	contactStringItem  = contactStringItem + TEXT("<Categories>") + element + TEXT("</Categories>");

	pContact->get_WebPage(&element);
	contactStringItem  = contactStringItem + TEXT("<WebPage>") + element + TEXT("</WebPage>");

	pContact->get_Business2TelephoneNumber(&element);
	contactStringItem  = contactStringItem + TEXT("<Business2TelephoneNumber>") + element + TEXT("</Business2TelephoneNumber>");
	
	pContact->get_RadioTelephoneNumber(&element);
	contactStringItem  = contactStringItem + TEXT("<RadioTelephoneNumber>") + element + TEXT("</RadioTelephoneNumber>");

	pContact->get_FileAs(&element);
	contactStringItem  = contactStringItem + TEXT("<FileAs>") + element + TEXT("</FileAs>");

	pContact->get_YomiCompanyName(&element);
	contactStringItem  = contactStringItem + TEXT("<YomiCompanyName>") + element + TEXT("</YomiCompanyName>");

	pContact->get_YomiFirstName(&element);
	contactStringItem  = contactStringItem + TEXT("<YomiFirstName>") + element + TEXT("</YomiFirstName>");

	pContact->get_YomiLastName(&element);
	contactStringItem  = contactStringItem + TEXT("<YomiLastName>") + element + TEXT("</YomiLastName>");

	pContact->get_Title(&element);
	contactStringItem  = contactStringItem + TEXT("<Title>") + element + TEXT("</Title>");

	pContact->get_MiddleName(&element);
	contactStringItem  = contactStringItem + TEXT("<MiddleName>") + element + TEXT("</MiddleName>");

	pContact->get_Suffix(&element);
	contactStringItem  = contactStringItem + TEXT("<Suffix>") + element + TEXT("</Suffix>");

	pContact->get_HomeAddressStreet(&element);
	contactStringItem  = contactStringItem + TEXT("<HomeAddressStreet>") + element + TEXT("</HomeAddressStreet>");

	pContact->get_HomeAddressCity(&element);
	contactStringItem  = contactStringItem + TEXT("<HomeAddressCity>") + element + TEXT("</HomeAddressCity>");

	pContact->get_HomeAddressState(&element);
	contactStringItem  = contactStringItem + TEXT("<HomeAddressState>") + element + TEXT("</HomeAddressState>");

	pContact->get_HomeAddressPostalCode(&element);
	contactStringItem  = contactStringItem + TEXT("<HomeAddressPostalCode>") + element + TEXT("</HomeAddressPostalCode>");

	pContact->get_HomeAddressCountry(&element);
	contactStringItem  = contactStringItem + TEXT("<HomeAddressCountry>") + element + TEXT("</HomeAddressCountry>");

	pContact->get_OtherAddressStreet(&element);
	contactStringItem  = contactStringItem + TEXT("<OtherAddressStreet>") + element + TEXT("</OtherAddressStreet>");

	pContact->get_OtherAddressCity(&element);
	contactStringItem  = contactStringItem + TEXT("<OtherAddressCity>") + element + TEXT("</OtherAddressCity>");

	pContact->get_OtherAddressPostalCode(&element);
	contactStringItem  = contactStringItem + TEXT("<OtherAddressPostalCode>") + element + TEXT("</OtherAddressPostalCode>");

	pContact->get_OtherAddressCountry(&element);
	contactStringItem  = contactStringItem + TEXT("<OtherAddressCountry>") + element + TEXT("</OtherAddressCountry>");

	pContact->get_BusinessAddressStreet(&element);
	contactStringItem  = contactStringItem + TEXT("<BusinessAddressStreet>") + element + TEXT("</BusinessAddressStreet>");

	pContact->get_BusinessAddressCity(&element);
	contactStringItem  = contactStringItem + TEXT("<BusinessAddressCity>") + element + TEXT("</BusinessAddressCity>");

	pContact->get_BusinessAddressState(&element);
	contactStringItem  = contactStringItem + TEXT("<BusinessAddressState>") + element + TEXT("</BusinessAddressState>");

	pContact->get_BusinessAddressPostalCode(&element);
	contactStringItem  = contactStringItem + TEXT("<BusinessAddressPostalCode>") + element + TEXT("</BusinessAddressPostalCode>");

	pContact->get_BusinessAddressCountry(&element);
	contactStringItem  = contactStringItem + TEXT("<BusinessAddressCountry>") + element + TEXT("</BusinessAddressCountry>");

	pContact->get_Body(&element);
	contactStringItem  = contactStringItem + TEXT("<Body>") + element + TEXT("</Body>");

	pContact->get_Birthday(&date);	

	wsprintf(tempDate, TEXT(""));	
	
	double toCompare = MAX_DATE_DOUBLE;

	if (date != toCompare) { // MAX_DATE_DOUBLE is set to 949999.00000, the nonsense value when in ppc date is not set...	
        doubleToSystemTimeHourZero(tempDate, date, TRUE);
		// doubleToSystemTime(tempDate, date);
	}
	contactStringItem = contactStringItem +  TEXT("<Birthday>") + tempDate + TEXT("</Birthday>");
	
	pContact->get_Anniversary(&date);
	wsprintf(tempDate, TEXT(""));
	if (date != toCompare) { 
        doubleToSystemTimeHourZero(tempDate, date, TRUE);
		// doubleToSystemTime(tempDate, date);
	}
	contactStringItem = contactStringItem +  TEXT("<Anniversary>") + tempDate + TEXT("</Anniversary>");

	contactStringItem = contactStringItem +  TEXT("</contact>");

}

/*
* Method that complete an contact object retrieving property value by an XML structure.
* It parse the XML structure, get the every property value using its name and set it into the object.
*
* @param pContact     : the contact object that contain every value
* @param ptrData      : the variable that contain the xml structure
*/

void completeContact(IContact *pContact, wchar_t * ptrData) {
		
		
		wchar_t* dummy = NULL;
		wchar_t* dummyEvent = NULL;		
		wchar_t localTemp [DIM_LOCAL_TEMP];

		double doubleDummy = MAX_DATE_DOUBLE;
		
		// complete fields for updating
		// BSTR
		dummyEvent = getElementContent(ptrData, TEXT ("FirstName"), NULL);
		pContact->put_FirstName (dummyEvent);
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("LastName"), NULL);
		pContact->put_LastName (dummyEvent);
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("CompanyName"), NULL);
		pContact->put_CompanyName (dummyEvent);
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("BusinessFaxNumber"), NULL);
		pContact->put_BusinessFaxNumber (dummyEvent);
		delete dummyEvent;dummyEvent=NULL;
	
		dummyEvent = getElementContent(ptrData, TEXT ("Department"), NULL);
		pContact->put_Department(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("Email1Address"), NULL);
		pContact->put_Email1Address(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("MobileTelephoneNumber"), NULL);
		pContact->put_MobileTelephoneNumber(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("OfficeLocation"), NULL);
		pContact->put_OfficeLocation(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("PagerNumber"), NULL);
		pContact->put_PagerNumber(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("BusinessTelephoneNumber"), NULL);
		pContact->put_BusinessTelephoneNumber(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("JobTitle"), NULL);
		pContact->put_JobTitle(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("HomeTelephoneNumber"), NULL);
		pContact->put_HomeTelephoneNumber(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("Email2Address"), NULL);
		pContact->put_Email2Address(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("Spouse"), NULL);
		pContact->put_Spouse(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("Email3Address"), NULL);
		pContact->put_Email3Address(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("Home2TelephoneNumber"), NULL);
		pContact->put_Home2TelephoneNumber(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;
		
		dummyEvent = getElementContent(ptrData, TEXT ("HomeFaxNumber"), NULL);
		pContact->put_HomeFaxNumber(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("CarTelephoneNumber"), NULL);
		pContact->put_CarTelephoneNumber(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("AssistantName"), NULL);
		pContact->put_AssistantName(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("AssistantTelephoneNumber"), NULL);
		pContact->put_AssistantTelephoneNumber(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("Children"), NULL);
		pContact->put_Children(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("Categories"), NULL);
		pContact->put_Categories(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("WebPage"), NULL);
		pContact->put_WebPage(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;
		
		dummyEvent = getElementContent(ptrData, TEXT ("Business2TelephoneNumber"), NULL);
		pContact->put_Business2TelephoneNumber(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("RadioTelephoneNumber"), NULL);
		pContact->put_RadioTelephoneNumber(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("FileAs"), NULL);
		pContact->put_FileAs(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("YomiCompanyName"), NULL);
		pContact->put_YomiCompanyName(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("YomiFirstName"), NULL);
		pContact->put_YomiFirstName(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("YomiLastName"), NULL);
		pContact->put_YomiLastName(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("Title"), NULL);
		pContact->put_Title(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("MiddleName"), NULL);
		pContact->put_MiddleName (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("Suffix"), NULL);
		pContact->put_Suffix(dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("HomeAddressStreet"), NULL);
		pContact->put_HomeAddressStreet (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;
		
		
		dummyEvent = getElementContent(ptrData, TEXT ("HomeAddressState"), NULL);
		pContact->put_HomeAddressState (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("HomeAddressCity"), NULL);
		pContact->put_HomeAddressCity (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("HomeAddressPostalCode"), NULL);
		pContact->put_HomeAddressPostalCode (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("HomeAddressCountry"), NULL);
		pContact->put_HomeAddressCountry (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("OtherAddressStreet"), NULL);
		pContact->put_OtherAddressStreet (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("OtherAddressCity"), NULL);
		pContact->put_OtherAddressCity (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("OtherAddressState"), NULL);
		pContact->put_OtherAddressState (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("OtherAddressPostalCode"), NULL);
		pContact->put_OtherAddressPostalCode (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("OtherAddressCountry"), NULL);
		pContact->put_OtherAddressCountry (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("BusinessAddressStreet"), NULL);
		pContact->put_BusinessAddressStreet (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;
		
		dummyEvent = getElementContent(ptrData, TEXT ("BusinessAddressCity"), NULL);
		pContact->put_BusinessAddressCity (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("BusinessAddressState"), NULL);
		pContact->put_BusinessAddressState (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("BusinessAddressPostalCode"), NULL);
		pContact->put_BusinessAddressPostalCode (dummyEvent);				
		delete dummyEvent;

		dummyEvent = getElementContent(ptrData, TEXT ("BusinessAddressCountry"), NULL);
		pContact->put_BusinessAddressCountry (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		dummyEvent = getElementContent(ptrData, TEXT ("Body"), NULL);
		pContact->put_Body (dummyEvent);				
		delete dummyEvent;dummyEvent=NULL;

		// tipo DATE
		dummyEvent = getElementContent(ptrData, TEXT ("Birthday"), NULL);
		if (dummyEvent == NULL || (wcscmp(dummyEvent, TEXT("")) == 0))
			pContact->put_Birthday(doubleDummy);
		else {
			DATE birth;
			systemTimeToDouble(dummyEvent, &birth, NULL);
			wsprintf(localTemp, TEXT("%f"), birth);			

			pContact->put_Birthday(birth);
			delete dummyEvent;
		}
		
		dummyEvent = getElementContent(ptrData, TEXT ("Anniversary"), NULL);
		if (dummyEvent == NULL || (wcscmp(dummyEvent, TEXT("")) == 0))
			pContact->put_Anniversary(doubleDummy);
		else {
			
			DATE anny;
			systemTimeToDouble(dummyEvent, &anny, NULL);
			pContact->put_Anniversary(anny);
			delete dummyEvent;
		}
	
}

/*
* The method calculate the CRC hash value for the contact item.
* It create the XML structure and calculate the crc value.
* Use to compare for understand the modified value!
*
* @param pContact : the contact object that contain every value
*/

long calculateContactHash (IContact* pContact) {
	
	CCrc32 cc = CCrc32();	
	string p = string();
	BSTR element = NULL;	    	

	populateContactStringItem(p, pContact);		

    BSTR dummy = p;

    long l = cc.crc32String(&dummy);
	
	return l;
}